pcl::ImageGrabber< PointT > Class Template Reference

`#include <pcl/io/image_grabber.h>`

Inheritance diagram for pcl::ImageGrabber< PointT >:

## Public Member Functions

| ImageGrabber (const std::string &dir, float frames_per_second=0, bool repeat=false, bool pclzf_mode=false)
| ImageGrabber (const std::string &depth_dir, const std::string &rgb_dir, float frames_per_second=0, bool repeat=false)
| ImageGrabber (const std::vector< std::string > &depth_image_files, float frames_per_second=0, bool repeat=false)
virtual | ~ImageGrabber () throw ()
| Empty destructor. More...
const boost::shared_ptr< const pcl::PointCloud< PointT > > | operator[] (size_t idx) const
| operator[] Returns the idx-th cloud in the dataset, without bounds checking. More...
size_t | size () const
| size Returns the number of clouds currently loaded by the grabber More...
Public Member Functions inherited from pcl::ImageGrabberBase
| ImageGrabberBase (const std::string &directory, float frames_per_second, bool repeat, bool pclzf_mode)
| Constructor taking a folder of depth+[rgb] images. More...
| ImageGrabberBase (const std::string &depth_directory, const std::string &rgb_directory, float frames_per_second, bool repeat)
| ImageGrabberBase (const std::vector< std::string > &depth_image_files, float frames_per_second, bool repeat)
| Constructor taking a list of paths to PCD files, that are played in the order they appear in the list. More...
| ImageGrabberBase (const ImageGrabberBase &src)
| Copy constructor. More...
ImageGrabberBase & | operator= (const ImageGrabberBase &src)
| Copy operator. More...
virtual | ~ImageGrabberBase () throw ()
| Virtual destructor. More...
virtual void | start ()
| Starts playing the list of PCD files if frames_per_second is > 0. More...
virtual void | stop ()
| Stops playing the list of PCD files if frames_per_second is > 0. More...
virtual void | trigger ()
| Triggers a callback with new data. More...
virtual bool | isRunning () const
| whether the grabber is started (publishing) or not. More...
virtual std::string | getName () const
virtual void | rewind ()
| Rewinds to the first PCD file in the list. More...
virtual float | getFramesPerSecond () const
| Returns the frames_per_second. More...
bool | isRepeatOn () const
| Returns whether the repeat flag is on. More...
bool | atLastFrame () const
| Returns if the last frame is reached. More...
std::string | getCurrentDepthFileName () const
| Returns the filename of the current indexed file. More...
std::string | getPrevDepthFileName () const
| Returns the filename of the previous indexed file SDM: adding this back in, but is this useful, or confusing? More...
std::string | getDepthFileNameAtIndex (size_t idx) const
| Get the depth filename at a particular index. More...
bool | getTimestampAtIndex (size_t idx, pcl::uint64_t &timestamp) const
| Query only the timestamp of an index, if it exists. More...
void | setRGBImageFiles (const std::vector< std::string > &rgb_image_files)
| Manually set RGB image files. More...
virtual void | setCameraIntrinsics (const double focal_length_x, const double focal_length_y, const double principal_point_x, const double principal_point_y)
| Define custom focal length and center pixel. More...
virtual void | getCameraIntrinsics (double &focal_length_x, double &focal_length_y, double &principal_point_x, double &principal_point_y) const
| Get the current focal length and center pixel. More...
void | setDepthImageUnits (float units)
| Define the units the depth data is stored in. More...
void | setNumberOfThreads (unsigned int nr_threads=0)
| Set the number of threads, if we wish to use OpenMP for quicker cloud population. More...
Public Member Functions inherited from pcl::Grabber
| Grabber ()
| Constructor. More...
virtual | ~Grabber () throw ()
| virtual desctructor. More...
template<typename T >
boost::signals2::connection | registerCallback (const boost::function< T > &callback)
| registers a callback function/method to a signal with the corresponding signature More...
template<typename T >
bool | providesCallback () const
| indicates whether a signal with given parameter-type exists or not More...
Public Member Functions inherited from pcl::FileGrabber< PointT >
virtual | ~FileGrabber ()
| Empty destructor. More...
virtual const boost::shared_ptr< const pcl::PointCloud< PointT > > | at (size_t idx) const
| at Returns the idx-th cloud in the dataset, with bounds checking More...

## Protected Member Functions

virtual void | publish (const pcl::PCLPointCloud2 &blob, const Eigen::Vector4f &origin, const Eigen::Quaternionf &orientation) const
Protected Member Functions inherited from pcl::ImageGrabberBase
size_t | numFrames () const
| Convenience function to see how many frames this consists of. More...
bool | getCloudAt (size_t idx, pcl::PCLPointCloud2 &blob, Eigen::Vector4f &origin, Eigen::Quaternionf &orientation) const
| Gets the cloud in ROS form at location idx. More...
Protected Member Functions inherited from pcl::Grabber
virtual void | signalsChanged ()
template<typename T >
boost::signals2::signal< T > * | find_signal () const
template<typename T >
int | num_slots () const
template<typename T >
void | disconnect_all_slots ()
template<typename T >
void | block_signal ()
template<typename T >
void | unblock_signal ()
void | block_signals ()
void | unblock_signals ()
template<typename T >
boost::signals2::signal< T > * | createSignal ()

## Protected Attributes

boost::signals2::signal< void(const boost::shared_ptr< const pcl::PointCloud< PointT > > &)> * | signal_
Protected Attributes inherited from pcl::Grabber
std::map< std::string, boost::signals2::signal_base * > | signals_
std::map< std::string, std::vector< boost::signals2::connection > > | connections_
std::map< std::string, std::vector< boost::signals2::shared_connection_block > > | shared_connections_

## Detailed Description

### template<typename PointT>
class pcl::ImageGrabber< PointT >

Definition at line 216 of file image_grabber.h.

## Constructor & Destructor Documentation

template<typename PointT >

pcl::ImageGrabber< PointT >::ImageGrabber | ( | const std::string & | dir,
|  | float | frames_per_second = `0`,
|  | bool | repeat = `false`,
|  | bool | pclzf_mode = `false`
| ) |  |

Definition at line 254 of file image_grabber.h.

References pcl::ImageGrabber< PointT >::signal_.

template<typename PointT >

pcl::ImageGrabber< PointT >::ImageGrabber | ( | const std::string & | depth_dir,
|  | const std::string & | rgb_dir,
|  | float | frames_per_second = `0`,
|  | bool | repeat = `false`
| ) |  |

Definition at line 265 of file image_grabber.h.

References pcl::ImageGrabber< PointT >::signal_.

template<typename PointT >

pcl::ImageGrabber< PointT >::ImageGrabber | ( | const std::vector< std::string > & | depth_image_files,
|  | float | frames_per_second = `0`,
|  | bool | repeat = `false`
| ) |  |

Definition at line 276 of file image_grabber.h.

References pcl::ImageGrabber< PointT >::signal_.

template<typename PointT >

virtual pcl::ImageGrabber< PointT >::~ImageGrabber | ( |  | ) |
throw | ( |
| ) |  |

inline virtual

Empty destructor.

Definition at line 234 of file image_grabber.h.

## Member Function Documentation

template<typename PointT >

const boost::shared_ptr< const pcl::PointCloud< PointT > > pcl::ImageGrabber< PointT >::operator[] | ( | size_t | idx | ) | const

virtual

operator[] Returns the idx-th cloud in the dataset, without bounds checking.

Note that in the future, this could easily be modified to do caching

Parameters

  [in] | idx | The frame to load

Implements pcl::FileGrabber< PointT >.

Definition at line 286 of file image_grabber.h.

References pcl::fromPCLPointCloud2(), pcl::ImageGrabberBase::getCloudAt(), pcl::PointCloud< PointT >::sensor_orientation_, and pcl::PointCloud< PointT >::sensor_origin_.

template<typename PointT >

void pcl::ImageGrabber< PointT >::publish | ( | const pcl::PCLPointCloud2 & | blob,
|  | const Eigen::Vector4f & | origin,
|  | const Eigen::Quaternionf & | orientation
| ) |  | const

protected virtual

Implements pcl::ImageGrabberBase.

Definition at line 308 of file image_grabber.h.

References pcl::fromPCLPointCloud2(), pcl::PointCloud< PointT >::sensor_orientation_, pcl::PointCloud< PointT >::sensor_origin_, and pcl::ImageGrabber< PointT >::signal_.

template<typename PointT >

size_t pcl::ImageGrabber< PointT >::size | ( |  | ) | const

virtual

size Returns the number of clouds currently loaded by the grabber

Implements pcl::FileGrabber< PointT >.

Definition at line 301 of file image_grabber.h.

References pcl::ImageGrabberBase::numFrames().

## Member Data Documentation

template<typename PointT >

boost::signals2::signal<void (const boost::shared_ptr<const pcl::PointCloud<PointT> >&)>* pcl::ImageGrabber< PointT >::signal_

protected

Definition at line 249 of file image_grabber.h.

Referenced by pcl::ImageGrabber< PointT >::ImageGrabber(), and pcl::ImageGrabber< PointT >::publish().

The documentation for this class was generated from the following file:

- /build/pcl-0nnAvv/pcl-1.7.2/io/include/pcl/io/image_grabber.h